# frozen_string_literal: true

require 'net/http'
require 'fileutils'
require 'yaml'
require 'socket'
require 'uri'
require 'json'
require 'tempfile'
require 'cgi'
require 'optparse'
require 'date'
require 'time'
require 'logger'
require 'asciidoctor'
require 'asciidoctor/extensions'
require 'asciidoctor-pdf'
require 'zip'
require_relative 'VERSION'

# TODO: add test to see if datasource default formats are applied
# TODO: add test for render-height and render-width, as they are not forwarded
# TODO: show convert-backend, template language and all variables in webservice overview
# TODO: add automated test against grafana playground before building a new release
# TODO: allow registration of files to be defined in config file
# TODO: PRIO: check in cloud - variables fetched from queries are replaced with SQL query instead of the resolved values, which can lead to issues, e.g. when using that in a function as SUBSTRING
# TODO: PRIO: allow multiple report classes in configuration file including possibility to decide for the individual class for each rendering call
# TODO: add configuration example to README
# TODO: find a way, how to automatically update test grafana responses with _real_ grafana responses
# TODO: append necessary variables on demo report creation for plain SQL queries, as they are lacking the grafana reference

folders = [
  %w[grafana],
  %w[grafana_reporter logger],
  %w[grafana_reporter],
  %w[grafana_reporter asciidoctor extensions],
  %w[grafana_reporter asciidoctor],
  %w[grafana_reporter erb],
  %w[grafana_reporter application]
]
folders.each { |folder| Dir[File.join(__dir__, *folder, '*.rb')].sort.each { |file| require_relative file } }
